<template>
  <gp-timeline-entry icon="check"
                     :subject-icon="subjectProperties.icon"
                     :subject="subjectProperties.name"
                     :title="task.name"
                     :hide-icon="hideIcon"
                     :opened="opened"
                     :comments-subject="task">
    <div v-if="task.notes" class="_writing">{{ task.notes }}</div>
  </gp-timeline-entry>
</template>
<script>
import GpTimelineEntry from '../TimelineEntry/TimelineEntry.vue'

import Task from '@/vue/classes/models/Task'
import { subjectProperties } from '@/vue/tools/SubjectProperties'

/**
 * Displays a task in a Timeline
 *
 * @preset default { "props": { "task": { "name": "Do something", "subject": { "className": "Map", "name": "My map" }, "notes": "... and do it well", "commentsCount": 0 } } }
 */
export default {
  name: 'GpTaskTimelineEntry',
  components: { GpTimelineEntry },
  props: {
    /** Task to display */
    task: { required: true, type: Task },
    /** Whether to hide the big icon */
    hideIcon: { required: false, type: Boolean, default: false },
    /** Whether the entry is opened on load */
    opened: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      showComments: false,
      commentsShownOnce: false,
    }
  },
  computed: {
    subjectProperties () {
      return subjectProperties(this.task.subject)
    },
  },
}
</script>
